/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.gateway.common_gateway.wrapper;

import cn.hutool.core.lang.Assert;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.gateway.common_gateway.entity.vo.AppActivityVO;
import org.springblade.ldt.activity.entity.Activity;
import org.springblade.ldt.activity.entity.JoinRecord;
import org.springblade.ldt.activity.service.IActivityService;
import org.springblade.ldt.activity.vo.ActivityVO;
import org.springblade.ldt.activity.vo.JoinRecordVO;
import org.springblade.ldt.user.vo.UserBankVO;

import java.math.BigDecimal;
import java.util.Objects;
import java.util.Optional;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-09-03
 */
public class AppJoinRecordWrapper extends BaseEntityWrapper<JoinRecord, AppActivityVO>  {

	private IActivityService activityService;

	public AppJoinRecordWrapper(IActivityService activityService) {
		this.activityService = activityService;
	}

	public static AppJoinRecordWrapper build(IActivityService activityService) {
		return new AppJoinRecordWrapper(activityService);
 	}

	@Override
	public AppActivityVO entityVO(JoinRecord joinRecord) {
		Long activityId = joinRecord.getActivityId();
		Activity activity = activityService.getById(activityId);
		Assert.notNull(activity, "找不到参加的活动信息");
		AppActivityVO appActivityVO = Objects.requireNonNull(BeanUtil.copy(activity, AppActivityVO.class));
		if (appActivityVO != null) {
			appActivityVO.setJoinRecordId(joinRecord.getId());
			BigDecimal discount = Optional.ofNullable(joinRecord.getDiscount()).orElseGet(activity::getDiscount);
			appActivityVO.setDiscount(discount);
		}
		return appActivityVO;
	}

}
